<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XPhoneButtonTemplate StructType
 * @subpackage Structs
 */
class XPhoneButtonTemplate extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - documentation: The template's name
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The basePhoneTemplateName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var XFkType
     */
    public $basePhoneTemplateName;
    /**
     * The buttons
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var Buttons
     */
    public $buttons;
    /**
     * Constructor method for XPhoneButtonTemplate
     * @uses XPhoneButtonTemplate::setName()
     * @uses XPhoneButtonTemplate::setBasePhoneTemplateName()
     * @uses XPhoneButtonTemplate::setButtons()
     * @param string $name
     * @param XFkType $basePhoneTemplateName
     * @param Buttons $buttons
     */
    public function __construct($name = null, XFkType $basePhoneTemplateName = null, Buttons $buttons = null)
    {
        $this
            ->setName($name)
            ->setBasePhoneTemplateName($basePhoneTemplateName)
            ->setButtons($buttons);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return XPhoneButtonTemplate
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get basePhoneTemplateName value
     * @return XFkType
     */
    public function getBasePhoneTemplateName()
    {
        return $this->basePhoneTemplateName;
    }
    /**
     * Set basePhoneTemplateName value
     * @param XFkType $basePhoneTemplateName
     * @return XPhoneButtonTemplate
     */
    public function setBasePhoneTemplateName(XFkType $basePhoneTemplateName = null)
    {
        $this->basePhoneTemplateName = $basePhoneTemplateName;
        return $this;
    }
    /**
     * Get buttons value
     * @return Buttons|null
     */
    public function getButtons()
    {
        return $this->buttons;
    }
    /**
     * Set buttons value
     * @param Buttons $buttons
     * @return XPhoneButtonTemplate
     */
    public function setButtons(Buttons $buttons = null)
    {
        $this->buttons = $buttons;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XPhoneButtonTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
